/*
* Jalview - A Sequence Alignment Editor and Viewer
* Copyright (C) 2005 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
package jalview.schemes;

import jalview.datamodel.*;

import java.awt.*;

import java.util.*;


public class PIDColourScheme extends ResidueColourScheme {
    public Color[] pidColours;
    public float[] thresholds;
    SequenceGroup group;

    public PIDColourScheme() {
        this.pidColours = ResidueProperties.pidColours;
        this.thresholds = ResidueProperties.pidThresholds;
    }

    public Color findColour(String s, int j) {
        if ((threshold != 0) && !aboveThreshold(s, j)) {
            return Color.white;
        }

        Color c = Color.white;
        Hashtable hash = (Hashtable) consensus.elementAt(j);

        double sc = 0;

        if ((Integer.parseInt(hash.get("maxCount").toString()) != -1) &&
                hash.contains(s)) {
            sc = (((Integer) hash.get(s)).intValue() * 100.0) / ((Integer) hash.get(
                    "size")).intValue();

            // MC Should be isGap
            if (!jalview.util.Comparison.isGap((s.charAt(0)))) {
                for (int i = 0; i < thresholds.length; i++) {
                    if (sc > thresholds[i]) {
                        c = pidColours[i];

                        break;
                    }
                }
            }
        }

        return c;
    }
}
